#
# Spec file for packaging OFED kernel modules (and corresponding
# header files).
#

%define kversion 2.6.18-92.1.17.el5

Name:		ofa-%{kversion}
Summary:	OpenFabrics Infiniband Kernel Modules
Prereq:		/sbin/ldconfig
Version:	1.3.1
Release:	10.20080603
License:	GPL/BSD
Url:		http://www.openfabrics.org/
Group:		System Environment/Base
Source:		ofa-kernel-%{version}.tgz

Patch0:		less-verbose-build.patch
Patch1:		ib-bonding-configure.patch
Patch2:		ib-bonding-source.patch
Patch3:		kernel-addons-backport-2.6.18-EL5.1.patch

# RDS patches
Patch4:         0001-RDS-Clarify-comment-on-rds_poll.patch
Patch5:         0002-RDS-introduce-rds_send_get_message.patch
Patch6:         0003-RDS-Track-whether-RDMA-S-G-list-is-DMA-mapped.patch
Patch7:         0004-RDS-Another-fix-for-RDMA-signalling.patch
Patch8:         0005-RDS-Use-vmalloc-in-rds_ib_setup_qp.patch
Patch9:         0006-RDS-increase-size-of-stats-counters.patch
Patch10:        0007-RDS-Expose-info-on-IB-connections.patch
Patch11:        0008-RDS-Extend-IB-connection-info-to-include-settings.patch
Patch12:        0009-RDS-Wake-up-send-worker-after-TX-queue-full-conditi.patch
Patch13:        0010-RDS-Send-notification-for-cancelled-RDMA-ops.patch
Patch14:        0011-RDS-Add-mr_pool_depleted-stats-counter.patch
Patch15:        0012-RDS-rds-info-k-should-display-inode-number.patch
Patch16:        0013-RDS-Remote-spurious-variable-name-from-stats.patch
Patch17:        0014-Revert-RDS-Wake-up-send-worker-after-TX-queue-full.patch
Patch18:        0015-RDS-Fix-compilation-issue-on-PPC64-and-IA64.patch
Patch19:        0016-net-rds-Add-support-for-RDMA_CM_EVENT_ADDR_CHANGE-e.patch
Patch20:        0017-RDS-Fix-race-in-rds_send_xmit.patch
Patch21:        0018-RDS-IB-silence-harmless-kernel-message.patch
Patch22:        0019-RDS-IB-Increase-FMR-pool-size-to-4k.patch
Patch23:        0020-RDS-IB-remove-error-message-on-connection-race.patch
Patch24:        0021-RDS-IB-Don-t-count-congestion-messages-for-determin.patch
Patch25:        0022-RDS-IB-Always-set-i_ack_next-in-rds_ib_set_ack.patch
Patch26:        0023-RDS-Fix-spin-between-poll-and-sendmsg-each-retu.patch
Patch27:        0024-RDS-Fix-compilation-issue-due-to-EVENT_ADDR_CHANGE.patch
Patch28:        0025-RDS-Fix-send-ring-leak.patch
Patch29:        0026-RDS-Fix-race-between-incoming-packet-and-socket-clo.patch
Patch30:        0027-RDS-Don-t-send-congestion-maps-over-IB-loopback.patch
Patch31:        0028-RDS-rewrite-connection-and-ipaddr-list-handling-for.patch
Patch32:        0029-RDS-Fix-a-congestion-hang-under-stress.patch
Patch33:        0030-RDS-Remove-TCP-transport.patch
Patch34:        0031-RDS-Alloc-dma-page-list-using-GFP_KERNEL.patch
Patch35:        0032-RDS-Fix-warnings-on-32-bit.patch
Patch36:        0033-RDS-ib-fix-for-RDS-RDMA-mode-does-not-work-on-QLog.patch
Patch37:        0034-RDS-ib-suggested-minor-code-change.patch
Patch38:        0035-RDS-ib-cleanup-unused-variable.patch
Patch39:        0036-RDS-Use-atomic-bitops-when-updating-congestion-map.patch
Patch40:        0037-RDS-Clear-cong-map-for-closed-sockets.patch
Patch41:        0038-RDS-Redo-c_map_bytes-fix-added-test-for-c_map_queu.patch
Patch42:        0039-RDS-Don-t-return-congested-until-used-space-reduces.patch
Patch43:        0040-RDS-Add-dynamic-tracing.patch
Patch44:        0041-RDS-Start-making-use-of-rdstrace-facility.patch
Patch45:        0042-RDS-Fix-connections-to-127.x.x.x.patch
Patch46:        0043-RDS-Set-retry_count-to-2-and-make-modifiable-via-mo.patch
Patch47:        0044-RDS-Fix-m_rs_lock-deadlock.patch

BuildRoot:	%{?build_root:%{build_root}}%{!?build_root:/var/tmp/OFED}
Vendor:		OpenFabrics
Requires:       kernel = %{kversion}
BuildRequires:  kernel-devel = %{kversion}
#BuildRequires:	sysfsutils-devel

%description
Infiniband kernel modules, providing the core functionality including
the IB verbs layer, drivers for a variety of adapaters, management
modules, and upper layer protocols. This package is compiled for
the default kernel.

# Turn ons and offs
%define builddef        1
%define buildpae        0
%define buildxen        0

%ifarch i686
%define karch		i686
%define buildpae        1
%define buildxen        1
%endif

%ifarch x86_64
%define karch		x86_64
%define buildxen        1
%endif

%if %{buildpae}
%package -n %{name}PAE
Summary:        OpenFabrics Infiniband Kernel Modules for the PAE kernel
Group:          System Environment/Base
Requires:       kernel-PAE = %{kversion}
BuildRequires:  kernel-PAE-devel = %{kversion}

%description -n %{name}PAE
Infiniband kernel modules, providing the core functionality including
the IB verbs layer, drivers for a variety of adapaters, management
modules, and upper layer protocols. This package is compiled for 
the PAE kernel.
%endif

%if %{buildxen}
%package -n %{name}xen
Summary:        OpenFabrics Infiniband Kernel Modules for the xen kernel
Group:          System Environment/Base
Requires:       kernel-xen = %{kversion}
BuildRequires:  kernel-xen-devel = %{kversion}

%description -n %{name}xen
Infiniband kernel modules, providing the core functionality including
the IB verbs layer, drivers for a variety of adapaters, management
modules, and upper layer protocols. This package is compiled for
the xen kernel.
%endif


%prep

%setup -q -n ofa_kernel-%{version}
%patch0 -p1
%patch1 -p1
%patch2 -p1
%patch3 -p1

# RDS patches
%patch4 -p1
%patch5 -p1
%patch6 -p1
%patch7 -p1
%patch8 -p1
%patch9 -p1
%patch10 -p1
%patch11 -p1
%patch12 -p1
%patch13 -p1
%patch14 -p1
%patch15 -p1
%patch16 -p1
%patch17 -p1
%patch18 -p1
%patch19 -p1
%patch20 -p1
%patch21 -p1
%patch22 -p1
%patch23 -p1
%patch24 -p1
%patch25 -p1
%patch26 -p1
%patch27 -p1
%patch28 -p1
%patch29 -p1
%patch30 -p1
%patch31 -p1
%patch32 -p1
%patch33 -p1
%patch34 -p1
%patch35 -p1
%patch36 -p1
%patch37 -p1
%patch38 -p1
%patch39 -p1
%patch40 -p1
%patch41 -p1
%patch42 -p1
%patch43 -p1
%patch44 -p1
%patch45 -p1
%patch46 -p1
%patch47 -p1

sh ./configure.bonding  --kernel-version %{kversion}

%build
rm -rf $RPM_BUILD_ROOT

local_configure()
{
# This freakin stupid rpmbuild 4.4.2 doesn't seem to understand
# line continuations via backslash :-(
# Hence this gobbledigook
options="
 --kernel-version="$1"
 --modules-dir=/lib/modules/"$1"
 --kernel-sources=/usr/src/kernels/"$1"-"$2"
 --without-quilt
 --with-core-mod
 --with-ipoib-mod
 --with-ipoib-cm
 --with-bonding-mod
 --with-user_mad-mod
 --with-user_access-mod
 --with-addr_trans-mod
 --with-madeye-mod
 --with-mthca-mod
 --with-mlx4-mod
 --with-cxgb3-mod
 --with-qlgc_vnic-mod
 --with-nes-mod
 --with-rds-mod
 --with-sdp-mod
 --with-srp-mod
 --with-srp-target-mod
 --with-iser-mod
"
./configure $options
}

%if %{builddef}
local_configure "%{kversion}" "%{karch}"

# Include the header files
rm -rf $RPM_BUILD_ROOT/%{_prefix}/src/%name
mkdir -p $RPM_BUILD_ROOT/%{_prefix}/src/%name
cp -a include $RPM_BUILD_ROOT/%{_prefix}/src/%name

make
make install_kernel DESTDIR=$RPM_BUILD_ROOT # MODULES_DIR=%{LIB_MOD_DIR}

MOD_DIR=$RPM_BUILD_ROOT/lib/modules/%{kversion}
modules_dir=`ls -d $MOD_DIR`
if [ -d $modules_dir/kernel ]; then
   mv $modules_dir/kernel $modules_dir/updates
fi

make clean_kernel

# Build the list of files to include. It's easier to do it this
# way that trying to figure out exactly which kernel modules get
# built and installed.
(
	cd $RPM_BUILD_ROOT
	find usr/src/%{name} -type d | sed 's:^:%dir /:'
	find usr/src/%{name} -type f | sed 's:^:/:'
	find lib/modules/%{kversion}/updates -type f | sed 's:^:/:'
) > files-def
%endif

%if %{buildpae}
local_configure "%{kversion}PAE" "%{karch}"

# Include the header files
rm -rf $RPM_BUILD_ROOT/%{_prefix}/src/%name
mkdir -p $RPM_BUILD_ROOT/%{_prefix}/src/%name
cp -a include $RPM_BUILD_ROOT/%{_prefix}/src/%name

make
make install_kernel DESTDIR=$RPM_BUILD_ROOT # MODULES_DIR=%{LIB_MOD_DIR}

MOD_DIR=$RPM_BUILD_ROOT/lib/modules/%{kversion}PAE
modules_dir=`ls -d $MOD_DIR`
if [ -d $modules_dir/kernel ]; then
   mv $modules_dir/kernel $modules_dir/updates
fi

make clean_kernel

# Build the list of files to include. It's easier to do it this
# way that trying to figure out exactly which kernel modules get
# built and installed.
(
	cd $RPM_BUILD_ROOT
	find usr/src/%{name} -type d | sed 's:^:%dir /:'
	find usr/src/%{name} -type f | sed 's:^:/:'
	find lib/modules/%{kversion}PAE/updates -type f | sed 's:^:/:'
) > files-pae

%endif

%if %{buildxen}
local_configure "%{kversion}xen" "%{karch}"

# Include the header files
rm -rf $RPM_BUILD_ROOT/%{_prefix}/src/%name
mkdir -p $RPM_BUILD_ROOT/%{_prefix}/src/%name
cp -a include $RPM_BUILD_ROOT/%{_prefix}/src/%name

make
make install_kernel DESTDIR=$RPM_BUILD_ROOT # MODULES_DIR=%{LIB_MOD_DIR}

MOD_DIR=$RPM_BUILD_ROOT/lib/modules/%{kversion}xen
modules_dir=`ls -d $MOD_DIR`
if [ -d $modules_dir/kernel ]; then
   mv $modules_dir/kernel $modules_dir/updates
fi

make clean_kernel

# Build the list of files to include. It's easier to do it this
# way that trying to figure out exactly which kernel modules get
# built and installed.
(
	cd $RPM_BUILD_ROOT
	find usr/src/%{name} -type d | sed 's:^:%dir /:'
	find usr/src/%{name} -type f | sed 's:^:/:'
	find lib/modules/%{kversion}xen/updates -type f | sed 's:^:/:'
) > files-xen

%endif

%install
# Do nothing here

%clean
rm -rf "$RPM_BUILD_ROOT"

%if %{builddef}
%post
/sbin/depmod -ae %{kversion}

%postun
/sbin/depmod -ae %{kversion}

%files -f files-def
%defattr(-,root,root)
%endif

%if %{buildpae}
%post -n %{name}PAE
/sbin/depmod -ae %{kversion}PAE

%postun -n %{name}PAE
/sbin/depmod -ae %{kversion}PAE

%files -f files-pae -n %{name}PAE
%defattr(-,root,root)
%endif

%if %{buildxen}
%post -n %{name}xen
/sbin/depmod -ae %{kversion}xen

%postun -n %{name}xen
/sbin/depmod -ae %{kversion}xen

%files -f files-xen -n %{name}xen
%defattr(-,root,root)
%endif

%changelog
* Wed Mar 04 2009 Andy Grover <andy.grover@oracle.com> - 1.3.1-10.20080603
- Add patches
  0044-RDS-Fix-m_rs_lock-deadlock.patch

* Tue Jan 13 2009 Andy Grover <andy.grover@oracle.com> - 1.3.1-9.20080603
- Add patches
  0043-RDS-Set-retry_count-to-2-and-make-modifiable-via-mo.patch

* Fri Dec 19 2008 Andy Grover <andy.grover@oracle.com> - 1.3.1-8.20080603
- Add patches
  0042-RDS-Fix-connections-to-127.x.x.x.patch

* Wed Dec 17 2008 Andy Grover <andy.grover@oracle.com> - 1.3.1-7.20080603
- Add patches
  0031-RDS-Alloc-dma-page-list-using-GFP_KERNEL.patch
  0032-RDS-Fix-warnings-on-32-bit.patch
  0033-RDS-ib-fix-for-RDS-RDMA-mode-does-not-work-on-QLog.patch
  0034-RDS-ib-suggested-minor-code-change.patch
  0035-RDS-ib-cleanup-unused-variable.patch
  0036-RDS-Use-atomic-bitops-when-updating-congestion-map.patch
  0037-RDS-Clear-cong-map-for-closed-sockets.patch
  0038-RDS-Redo-c_map_bytes-fix-added-test-for-c_map_queu.patch
  0039-RDS-Don-t-return-congested-until-used-space-reduces.patch
  0040-RDS-Add-dynamic-tracing.patch
  0041-RDS-Start-making-use-of-rdstrace-facility.patch

* Mon Nov 10 2008 Andy Grover <andy.grover@oracle.com> - 1.3.1-6.20080603
- Remove patch
  0023-RDS-Fix-compilation-error.patch
- Add patches
  0023-RDS-Fix-spin-between-poll-and-sendmsg-each-retu.patch
  0024-RDS-Fix-compilation-issue-due-to-EVENT_ADDR_CHANGE.patch
  0025-RDS-Fix-send-ring-leak.patch
  0026-RDS-Fix-race-between-incoming-packet-and-socket-clo.patch
  0027-RDS-Don-t-send-congestion-maps-over-IB-loopback.patch
  0028-RDS-rewrite-connection-and-ipaddr-list-handling-for.patch
  0029-RDS-Fix-a-congestion-hang-under-stress.patch
  0030-RDS-Remove-TCP-transport.patch

* Thu Sep 04 2008 Andy Grover <andy.grover@oracle.com> - 1.3.1-5.20080603
- Uncomment Patch12
  0009-RDS-Wake-up-send-worker-after-TX-queue-full-conditi.patch
  and add patches
  0015-RDS-Fix-compilation-issue-on-PPC64-and-IA64.patch
  0016-net-rds-Add-support-for-RDMA_CM_EVENT_ADDR_CHANGE-e.patch
  0017-RDS-Fix-race-in-rds_send_xmit.patch
  0018-RDS-IB-silence-harmless-kernel-message.patch
  0019-RDS-IB-Increase-FMR-pool-size-to-4k.patch
  0020-RDS-IB-remove-error-message-on-connection-race.patch
  0021-RDS-IB-Don-t-count-congestion-messages-for-determin.patch
  0022-RDS-IB-Always-set-i_ack_next-in-rds_ib_set_ack.patch
  0023-RDS-Fix-compilation-error.patch
   
* Thu Jun 26 2008 Srinivas Maturi <srinivas.maturi@oracle.com> - 1.3.1-4.20080603
- Comment out/remove this patch:
  0009-RDS-Wake-up-send-worker-after-TX-queue-full-conditi.patch.
  Enabled configure to build srpt module.

* Fri Jun 20 2008 Van Okamura <van.okamura@oracle.com> - 1.3.1-3.20080603
- Use updated patches from [olaf.kirch@oracle.com]:
  0001-RDS-Clarify-comment-on-rds_poll.patch
  0002-RDS-introduce-rds_send_get_message.patch
  0003-RDS-Track-whether-RDMA-S-G-list-is-DMA-mapped.patch
  0004-RDS-Another-fix-for-RDMA-signalling.patch
  0005-RDS-Use-vmalloc-in-rds_ib_setup_qp.patch
  0006-RDS-increase-size-of-stats-counters.patch
  0007-RDS-Expose-info-on-IB-connections.patch
  0008-RDS-Extend-IB-connection-info-to-include-settings.patch
  0009-RDS-Wake-up-send-worker-after-TX-queue-full-conditi.patch
  0010-RDS-Send-notification-for-cancelled-RDMA-ops.patch
  0011-RDS-Add-mr_pool_depleted-stats-counter.patch
  0012-RDS-rds-info-k-should-display-inode-number.patch
  0013-RDS-Remote-spurious-variable-name-from-stats.patch
  0014-RDS-Increase-default-FMR-pool-size-to-4K.patch

* Wed Jun 11 2008 Srinivas Maturi <srinivas.maturi@oracle.com> - 1.3.1-2.20080603
- Added these RDS patches from [olaf.kirch@oracle.com]
    rds-poll-comment.patch, rds-send-find-message.patch, rds-rdma-tracked-mapped.patch,
    rdma-error-propagation.patch, rds-ib-ring-vmalloc.patch, rds-bigger-byte-counters.patch
    rds-ib-connection-info.patch, rds-ib-tx-pressure.patch, rds-cancel-notify.patch
    rds-get-mr-fail-stats.patch, and rds-sock-info-inum.patch
- Replaced the tarball from the OFED's ofa-kernel src rpm of OFED-1.3.1 build

* Tue Jun 03 2008 Srinivas Maturi <srinivas.maturi@oracle.com> - 1.3.1-2.20080529
- Removed the ib-bonding.patch based on ib-bonding-0.9.0-24 package from OFED
  and added ib-bonding-configure.patch and ib-bonding-source.patch based on
  ib-bonding-0.9.0-25 from OFED-1.3.1-rc3
- Added kernel-addons-backport-2.6.18-EL5.1.patch to fix build of ib-bonding 
  module for EL5.1 kernels
- Removed rhel5u2-build.patch as the tarball in ofa-kernel src rpm from
  OFD-1.3.1-rc3 supports EL5.2 kernels

* Tue Jun 02 2008 Srinivas Maturi <srinivas.maturi@oracle.com> - 1.3.1-1.20080529
- Replaced the tarball from the OFED's ofa-kernel src rpm of OFED-1.3.1-rc3 build
- Added patch rdma-fix-failure.patch [richard.frank@oracle.com]
- Commented ib-bonding.patch 

* Tue May 20 2008 Srinivas Maturi <srinivas.maturi@oracle.com> - 1.3-1.20080513
- Added ib-bonding.patch based on ib-bonding-0.9.0-24 package from OFED-1.3.1
  to package the ib bonding kernel module in ofa 

* Wed May 14 2008 Srinivas Maturi <srinivas.maturi@oracle.com> - 1.3-1.20080513
- Replaced the tarball from the OFED's ofa-kernel src rpm of 20080513 build
- Update rhel5u2-build.patch based on this new tarball
- Update less-verbose-build.patch

* Mon May 08 2008 Srinivas Maturi <srinivas.maturi@oracle.com> - 1.3-0.2
- Added patch rhel5u2-build.patch to build in (RH)EL5 U2
- Add support to build for all kernel flavors for i386/x86_64 arch
- Add postun section and change package name

* Mon Apr 28 2008 Olaf Kirch <olaf.kirch@oracle.com>
- Update specfile enabling more modules to build

* Mon Apr 14 2008 Olaf Kirch <olaf.kirch@oracle.com>
 - Initial packaging of OFED 1.3 for OEL5
